<?php
/*

 $Id: admin.php,v 1.25 2003/11/11 22:44:44 vollmerk Exp $
 $Source: /data/cvsroot/maintain/docs/admin.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/*!
	@header Admin Document
	This document points off to all the administrative functions
*/

/* Do House Cleaning */
	require "../modules/config.php";

        if (!check_session()) { logout(); }
	
	setup_user_environment($action, $zone_id);
/* End House Cleaning */

// Only admins here!
if ( ! $user->is_admin AND !$user->is_setup_user()) {
	header("Location: " . $conf['web_path'] . "/index.php");
	exit();
	}

/* Display the header */
show_template('header'); 

if ($action == 'new_network') {

	/* Show the new_network */
	require ($conf['prefix'] . "/templates/new_network.inc");


} //action == new_network

/*!
	@function is_setup_user
	@discussion if they havn't submited anything and are the setup user
*/
elseif (!$action AND $user->is_setup_user()) {

        require($conf['prefix'] . "/templates/maintain_setup.inc");

} 
/*!
	@function maintain_setup
	@discussion only called when first setting up, after submission
*/
elseif ($action == 'maintain_setup') {

	// New Pass isn't the same as the confirm'd pass
	if ($new_pass !== $confirm_pass) { 
		$conf['error']->add_error('confirm_pass',"New Passwords are different");
	}

	if (strlen($new_pass) < 8) {
		$conf['error']->add_error('new_pass',"New Password is less than 8 characters");
	}

	if ($new_pass === $current_pass) {
		$conf['error']->add_error('new_pass', "Can not re-use current password");
	}
	
	// make sure their password isn't all letters, all digits and doesn't contain the origional password
	if (preg_match("/^[A-Za-z]+$|^[0-9]+$|changeme/",$new_pass)) {
		$conf['error']->add_error('new_pass', "New Password is not complex enough.");
	}

	// check the zone name
	$conf['zone']->check_name($name,0);

	if (!$conf['error']->error_state) {

		$user->set_passwd($new_pass,$username);
		$zone_id = $conf['zone']->new_zone($name,addslashes($description), addslashes($comment));
		$zone = new Zone($zone_id);
		
		$conf['ui']->display_confirmation("Setup Complete", "You have succesfully created your first zone, and reset your admin password, click continue to start using Maintain", $conf['web_path'] . "/index.php");
		

	} // if no error

	else {
		require($conf['prefix'] . "/templates/maintain_setup.inc");
	} // if error


} // maintain_setup

/*!
	@function make_admin
	@discussion Actually makes a full admin user
*/
elseif ($action == 'make_admin') {

	if ($type == 'ldap') { 
		
		if (!$user->check_auth_name($username)) {
			$conf['error']->add_error('username',"Username not found");
		}
	
	} // if type is ldap

	if ($type == 'mysql') {

		if (!$user->check_mysql_auth_name($username)) {
			$conf['error']->add_error('username',"Username not found");
		}
	} // if type is mysql


	if (!$conf['error']->error_state) { 

		// do a different check for admin incase they've found a way to 
		// fudge stuff up on us.
		$user->check_admin();

		if ($user->is_admin) {
			$user->add_full_admin($username);
			$conf['ui']->display_confirmation("Admin Create","$username is now a full administrator", $conf['web_path'] . "/admin.php");
		} // 
	
		else {
			$conf['ui']->show_access_denied();
		}

	} // if no error

	// if an error has happened
	else {
		require ($conf['prefix'] . "/templates/show_make_admin.inc");
	}


} // make_admin

/*!
	@function show_make_admin
	@discussion show the template to make a full admin
*/
elseif ($action == 'show_make_admin') {

	require ($conf['prefix'] . "/templates/show_make_admin.inc");

} // show_make_admin

else {
?>	
<p align="center" class="header1">Welcome to the Admin Section of Maintain</p>
<table border="0" cellpadding="4" cellspacing="0" width="100%" align="left">
<tr valign="top">
	<td width="50%">
		<? $conf['ui']->widget->admin_edit(); ?>
	</td>
	<td width="50%">
		<? $conf['ui']->widget->global_stats(); ?>
	</td>
</tr>
</table>
<br /><br /><br />

<? } ?>
<? show_template('footer');  ?>
