<?php
/*

 $Id: create_domain.php,v 1.12 2003/10/23 22:05:26 vollmerk Exp $
 $Source: /data/cvsroot/maintain/docs/create_domain.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.   

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
/*!
	@header Create Domain 
	This document is used to create domains new domains.
*/

/* Start House Cleaning */
	
	require "../modules/config.php";


	// do anything that needs to be done here
        if (!check_session()) { logout(); }
	
	// setup the user environment
	setup_user_environment($action, $zone_id);
/* End House Cleaning */


//Sorry, only admins here
if (! $user->is_admin) {
	header("Location:" .  $conf['web_path'] . "/index.php");
	exit();
}

show_template('header');

/*!
	@function create_domain
	@discussion do what ever you have to do to update the host if there's an error then we just re-display it
*/
if ($action == "create_domain") {

	// if they are creating a new subdomain, do the apprioate checking
	if ( $name and $domain_id ) {

		// build the new domain
		$domain = new Domain($domain_id);
		$name .= "." . $domain->name;
	
		$domain->check_name($name,0);	

		// if it looks good then let's go ahead and create the cname
		if (!$conf['error']->error_state) 
		{
			// note we're changing the domain_id from the master_domain to this
			//  new domain now
			$domain_id = $domain->new_domain($name, $domain_id);

			// domain has been created.. let's show them the confirmation
			$conf['ui']->display_confirmation("Domain $name created", "The domain name $name has been created, click continue to edit your new domain", $conf['web_path'] . "/domain.php?action=show_domain&amp;domain_id=$domain_id");	
			$created = "1";
		}
	}
	elseif ( $master_domain ) {
		$domain = new Domain(0);

		$domain->check_name($master_domain,0);
		
		// if it looks good then let's go ahead and create the cname
                if (!$conf['error']->error_state)
                {
                        $domain_id = $domain->new_domain($master_domain);
                        // domain has been created.. let's show them the confirmation
                        $conf['ui']->display_confirmation("New Master Domain $master_domain created", "The domain name $master_domain has been created, click continue to create an SOA record for your new domain.", $conf['web_path'] . "/soa.php?action=show_create&amp;domain_id=$domain_id");
                        $created = "1";
                }
	}

} // create domain

// if there was an error re-populate and post the error
if (!$created) {
?>
<p><font class="header2">Creating a new Domain</font></p>

<p><? if ($conf['error']->get_status('domain_name') ) { $conf['error']->show_message('domain_name'); } ?></p>

<form action="<?= $conf['web_path']; ?>/create_domain.php" enctype="multipart/form-data" method="post" style="Display:inline">
<input type="hidden" name="action" value="create_domain" />
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">

<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" align="left">
	<td title="<? $conf['help']->display_plain_txt("sub_domain"); ?>"><? $conf['help']->show_help_link('sub_domain'); ?> New Sub Domain Name:</td>
	<td>
		<input type="textbox" size="25" maxlength="127" name="name" />
		<? 
		$domain = new Domain(0);
                $domains = $domain->domains();

		$conf['ui']->show_domain_select($domains,$domain[0]->id);
		?>
	</td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" align="left">
	<td colspan="2"> or </td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" align="left">
	<td title="<? $conf['help']->display_plain_txt("master_domain"); ?>"><? $conf['help']->show_help_link('master_domain'); ?> New Master Domain Name:</td>
	<td><input type="textbox" size="35" maxlength="127" name="master_domain" /></td>
</tr>
<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
	<td colspan="2"><input type="submit" value="Create New Domain" /></td>
</tr>
</table>
</form>
<? show_template('bborder'); ?>
<? } ?>

<? show_template('footer'); ?>
