<?php
/*

 $Id: request_domain.php,v 1.13 2003/10/23 22:05:26 vollmerk Exp $
 $Source: /data/cvsroot/maintain/docs/request_domain.php,v $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/* Start House Keeping */

	require "../modules/config.php";


	// do anything that needs to be done here
        if (!check_session()) { logout(); }
	
	// setup the user environment
	setup_user_environment($action, $zone_id);

/* End House Keeping */

// once checked send the e-mail to $conf['domain_request_email']; 
if ($action == "request_domain") 
{
	// check their submission to make sure everything is there
	if (! preg_match('/orst\.edu|oregonstate.edu/', $new_domain_name) ) {
		$conf['error']->add_error('new_domain_name', "No valid domain name was entered.");	
	}
	//check for a few fields that must be filled out 
	if ($department_name <= " ") {
		$conf['error']->add_error('new_domain_name', "No Department Name was entered.");
		}
	if (! preg_match('/\w+\@\w+\.+\w+/', $group_email) ) {
		$conf['error']->add_error('new_domain_name', "No valid group e-mail address was entered.");
		}
	if (! preg_match('/\w+\@\w+\.+\w+/', $administrative_email) ) {
		$conf['error']->add_error('new_domain_name', "No valid administrative e-mail address was entered.");
		}
	if (! preg_match('/\w+\@\w+\.+\w+/', $technical_email) ) {
		$conf['error']->add_error('new_domain_name', "No valid technical contact e-mail address was entered.");
		}
	if ($acronym <= " ") { 
		$conf['error']->add_error('new_domain_name', "No Reason for Domain Name was entered.");
		}
	// if it looks good then let's go ahead and send the mail
	if (!$conf['error']->error_state) 
	{
		//setup the mail message
		$mail_message = "Please double check your request and then forward it to Net@oregonstate.edu\n\n" . 
				"Request for domain $new_domain_name from $user->username\n\n\n" .
				"Domain Name: $new_domain_name\n" . 
				"Department Name: $department_name\n" .
				"3rd Level Domains assigned to department: $trd_lv_domain\n\n" . 
				"Administrative Contact,\n\tName: $administrative_name\n\tTitle: $administrative_title\n\tE-mail: $administrative_email\n" .
				"Technical Contact,\n\tName: $technical_name\n\tTitle: $technical_title\n\tE-mail: $technical_email\n" .
				"Group E-mail: $group_email\n\n" .
				"Web Host: $web_host\n\n" . 
				"Reason for non-orst Domain: $non_orst_domain_reason\n\n" .
				"How the domain will be used: $domain_use\n\n" . 
				"Acronym Meaning: $acronym\n\n" .
				"Request for X.oregonstate.edu that is not dept name: $somename_domain";
		
		$conf['ui']->send_mail("Request for $new_domain_name domain","$mail_message","$administrative_email");
				
		//mail sent! woot
		show_template('header');
		$conf['ui']->display_confirmation("Domain Request Sent", "<b>The following has been sent:</b><br /><pre>$mail_message</pre>", $conf['web_path'] . "/index.php");
	}
	//if there was an error re-populate and post the error
	else { 
		show_template('header');
		$conf['ui']->display_confirmation("Domain Request Not Sent", "Your Domain Request was not sent due to the following errors.", $conf['web_path'] . "/request_domain.php"); 
		$conf['error']->show_message('new_domain_name');
	}
}


if ($action == "accepted") 
{
	show_template('header');
	show_template('dom.req'); 

 } // accepted
elseif ($action != "request_domain") {
	show_template('header');
	show_template('domain_policy'); 
?>
<br /><br />
<form action="<?= $conf['web_path']; ?>/request_domain.php" enctype="multipart/form-data" method="post" style="Display:inline"> 
<hr />
<p><input type="checkbox" name="action" value="accepted" /> I have read, and understand the above policy <br />
<input name="submit" value="Continue" type="submit" /></p>
</form>
<? } ?>

<? show_template('footer'); ?>
